﻿# -*- coding: utf-8 -*-
"""
Created on Thu Feb  1 16:55:41 2018

@author: jmarcos
"""
import matplotlib.pyplot as plt
import numpy as np
import random

# Definição dos parâmetros da RNA.
eta = 0.2               # Taxa de aprendizagem.
m   = 63                # Número de Neurônios na camada de entrada.
N   = 4                 # Número de Neurônios na camada intermediária.
L   = 63                # Número de Neurônios na camada de saída.

# Define os parâmetros da simulação.
numEpocas = 10000

# Carrega os padrões: A, B, C, D, E, J e K.
dados = np.loadtxt("Padroes.csv", dtype = "int", delimiter = ",")
padroes = []
inicio = 0;
fim = 9;
for i in range(7):
    padroes.append(dados[inicio:fim, :])
    inicio = inicio + 9
    fim = fim + 9
# Os padrões estão todos disponíveis na variável padroes.
    
# Inicia o gerador aleatório.
random.random()

# Define as matrizes de peso das sinapses aleatoriamente.
W1 = np.random.randn(N, m+1)
W2 = np.random.randn(L, N+1)

# Transforma a matriz 9 x 7 em um vetor de 63 x 1
X = padroes[0].reshape(m,1);

# Acrescentando o bias ao padrão; x agora é 64 x 1.     
Xb = np.vstack((1, X));

Y = np.random.choice([-1, 1], size = (9,7))
plt.figure()
plt.imshow(Y)

for i in range(numEpocas):
    # Etapa de feedfoward.
    O1 = np.tanh(np.dot(W1, Xb))    # Saída da primeira camada.

    # Acrescenta o bias porque a saída da primeira camada é a entrada da
    # segunda camada.
    O1 = np.vstack((1, O1))
    
    # Calcula a saída da RNA.
    Y = np.tanh(np.dot(W2, O1))
    
    # Etapa de cálculo do erro.
    e = Xb[1:] - Y    
    J = 0.5*np.dot(e.T, e)
    
    # Etapa de error backpropagation.
    delta2 = np.dot(np.diagflat(e), (1 - np.dot(np.diagflat(Y), Y)))
    Vdelta2 = np.dot(W2.T, delta2)
    delta1 = np.dot(np.diagflat(1 - np.dot(np.diagflat(O1), O1)), Vdelta2)
    
    # Atualização dos pesos.
    W1 = W1 + eta*np.dot(delta1[1:], Xb.T)
    W2 = W2 + eta*np.dot(delta2, O1.T)


plt.figure()
plt.imshow(Y.reshape(9,7))
plt.title("J = " + str(J))
